<?php

//////////
///
///   download.php
///
//////////

require_once('lib/authlevel.inc.php');
require_once('lib/db.inc.php');



/***************\
*   FUNCTIONS   *
\***************/

function serve_upload($upload_id)
{
   $ret = db_escape($upload_id);

   if(!is_success($ret)) {
      return false;
   }

   $sql  = "SELECT `content` ";
   $sql .= "FROM `upload` ";
   $sql .= "WHERE `upload_id` = '$upload_id'";
   $sql .= (($_SESSION['authlevel'] & AL_SERV) ? '' : " AND `backdoor_id` IN ('".implode("', '", $_SESSION['authbackdoorid'])."') ");

   return $sql;
}

function serve_log($log_id)
{
   $ret = db_escape($log_id);

   if(!is_success($ret)) {
      return false;
   }

   $sql  = "SELECT `longblob1` AS `content` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id' AND ";
   $sql .=       "`backdoor_id` IN ('".implode("', '", $_SESSION['authbackdoorid'])."')";

   return $sql;
}



/**********\
*   MAIN   *
\**********/

$authuser = (isset($_SESSION['authuser']) ? $_SESSION['authuser'] : '');
$authuserid = (isset($_SESSION['authuserid']) ? $_SESSION['authuserid'] : 'none');

error_log("download(begin): user=$authuser($authuserid)");

header('Content-Type: text/plain');

if(!isset($_POST['resource'])) {
   error_log("download(error): user=$authuser($authuserid), ".
                            'error="Invalid request"');
   error_log("download(ended): user=$authuser($authuserid)");

   header(true, true, 403);
   exit('Invalid request');
}

if($al & (AL_SERV | AL_TECH)) {
   switch($_POST['resource']) {
      case 'upload':
         $sql = serve_upload($_POST['upload_id']);
         break;
      default:
         break;
   }

}

if($al & AL_VIEW) {
   switch($_POST['resource']) {
      case 'log':
         $sql = serve_log($_POST['log_id']);
         break;
      default:
         break;
   }
}

if(!(isset($sql) && $sql)) {
   error_log("download(error): user=$authuser($authuserid), ".
                            'error="Invalid request"');
   error_log("download(ended): user=$authuser($authuserid)");

   header(true, true, 403);
   exit('Invalid request');
}

$ret = db_query($sql);

if(!is_success($ret)) {
   error_log("download(error): user=$authuser($authuserid), ".
                            'error="Invalid request"');
   error_log("download(ended): user=$authuser($authuserid)");

   header(true, true, 403);
   exit('Invalid request');
}

header('Content-Type: application/octet-stream');

echo $ret['payload'][0]->content->scalar;

error_log("download(ended): user=$authuser($authuserid)");

?>
