<?php

//////////
///
///   cert.inc.php
///
//////////

require_once('lib/commons.inc.php');



$dm['cert.get'] = array('func'   => 'cert_get',
                        'perm'   => AL_SERV | AL_TECH,
                        'escape' => true);



/***************\
*   FUNCTIONS   *
\***************/

function cert_get()
{
   if($_SESSION['authlevel'] & AL_SERV) {
      $sql  = "SELECT BINARY CONCAT(`cert`, `key`) AS `cert` ";
   } else {
      $sql  = "SELECT `cert` ";
   }
   $sql .= "FROM `cert` ";
   $sql .= "WHERE `cn` = 'server'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   if($_SESSION['authlevel'] & AL_SERV) {
      xmlrpc_set_type($ret['payload'][0]->cert, 'base64');
   }

   return success($ret['payload'][0]->cert);
}

?>
