<?php

//////////
///
///   group.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['group.add'] = array('func'   => 'group_add',
                         'perm'   => AL_ADMN,
                         'escape' => true);

$dm['group.mod'] = array('func'   => 'group_mod',
                         'perm'   => AL_ADMN,
                         'escape' => true);

$dm['group.del'] = array('func'   => 'group_del',
                         'perm'   => AL_ADMN,
                         'escape' => true);

$dm['group.get'] = array('func'   => 'group_get',
                         'perm'   => AL_ADMN,
                         'escape' => true);



/***************\
*   FUNCTIONS   *
\***************/

function group_add($group, $desc)
{
   $em[1062] = array('group', 'exists');

   $sql  = "INSERT INTO `group` (`group`, ";
   $sql .=                     "`desc`) ";
   $sql .= "VALUES ('$group', ";
   $sql .=         "'$desc')";

   $ret = db_query($sql, $em);

   if(!is_success($ret)) {
      return $ret;
   }

   $sql = "SELECT LAST_INSERT_ID() AS `group_id`";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   trace('group.add', "group=$group({$ret['payload'][0]->group_id})", 0, $ret['payload'][0]->group_id, 0, 0, 0);

   return success((integer)$ret['payload'][0]->group_id);
}

function group_mod($group_id, $group, $desc)
{
   $em[1062] = array('group', 'exists');

   trace('group.mod', "group=$group($group_id)", 0, $group_id, 0, 0, 0);

   $sql  = "UPDATE `group` ";
   $sql .= "SET `group` = '$group', ";
   $sql .=     "`desc` = '$desc' ";
   $sql .= "WHERE `group_id` = '$group_id'";

   return db_query($sql, $em);
}

function group_del($group_id)
{
   trace('group.del', "group_id=$group_id", 0, $group_id, 0, 0, 0);

   $sql  = "DELETE FROM `group` ";
   $sql .= "WHERE `group_id` = '$group_id'";

   return db_query($sql);
}

function group_get($group_id)
{
   $sql  = "SELECT `group_id`, ";
   $sql .=        "`group`, ";
   $sql .=        "`desc` ";
   $sql .= "FROM `group`";
   $sql .= ($group_id ? " WHERE `group_id` = '$group_id'" : '');

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   return $ret;
}

?>
